
/*
  Program : ga.c
  Comment : GA for `Knapsack Problem'
  compile : % make
  Author  : cԈW
  Date    : 2000.01.24
 */

#include "parameter.h"

void check_result();


/* global variables */
/* for Knapsack Problem */
int *item;
char *itemfile;

/* for GA */
int generation;
int gene[POP_SIZE][GENE_LENGTH];
int fitness[POP_SIZE];
int all_max_fitness;   /* SɂőKx */
int all_max_fitness_generation;
int all_max_fitness_index;
int all_max_fitness_gene[GENE_LENGTH];



/* usage() */
void usage()
{
    /* read args: a.out $seed_pop $seed_ga $max_generaion */
    fprintf(stderr,"# USAGE: prompt> a.out $Seed_Pop $Seed_GA $ItemList_for_Knapsack $Terminate_Generation\n");
    fprintf(stderr,"   $Seed_Pop : Seed's value to make initial poplation.\n");
    fprintf(stderr,"   $Seed_GA  : Seed's value to perform GA's operator.\n");
    
    exit(-1);
}   /* end of usage() */


main(int argc, char **argv)
{
    int i, j;
    int seed_pop;
    int seed_ga;
    int max_generation;


    /* initialize */
    i = 0;
    j = 0;
    seed_pop = 0;
    seed_ga = 0;
    max_generation = 0;
    generation = 0;
    item = (int *)malloc(sizeof(int)*ITEM_NUM);
    itemfile = (char *)malloc(sizeof(char)*1024);

    all_max_fitness = 0;
    all_max_fitness_generation = 0;
    all_max_fitness_index = 0;

    if( argc != 5 ){
	usage();
    }else{
	seed_pop = atoi(argv[1]);
	seed_ga = atoi(argv[2]);
	itemfile = argv[3];
	max_generation = atoi(argv[4]);
    }
    fprintf(stderr,"# reading args => seed_pop=%d, seed_ga=%d, itemfile=%s, max_generation=%d\n",seed_pop,seed_ga,itemfile,max_generation);


    /* initialize population */
    initialize_pop_binary(seed_pop);
    for(i=0; i<POP_SIZE; i++){
	fprintf(stderr,"gene no.%d = ",i);
	for(j=0; j<GENE_LENGTH; j++){
	    fprintf(stderr,"%d ",gene[i][j]);
	}
	fprintf(stderr,"\n");
    }

    /* reading itemfile */
    read_itemfile();
    for(i=0; i<ITEM_NUM; i++){
	fprintf(stderr,"item[%3d] = %d\n",i,*(item+i));
    };

    /* calculation of fitness */
    calc_fitness_pop();

    /* GA */
    for(generation=1; generation<max_generation; generation++){

	/* selection */
	roulette_selection();

	/* crossover */
	singlepoint_crossover();

	/* mutation */
	mutation_binary();

	/* fitness */
	calc_fitness_pop();

	check_result();

    } /* for(generation) */


    /* output */

    fprintf(stdout,"## GA finished!\n");
    fprintf(stdout,"Best of fitness = %d\n",all_max_fitness);
    fprintf(stdout,"Generation no.%d\n",all_max_fitness_generation);
    fprintf(stdout,"gene no.%d = ",all_max_fitness_index);
    for(i=0; i<GENE_LENGTH; i++)
	fprintf(stdout,"%3d",all_max_fitness_gene[i]);
    fprintf(stdout,"\n");

}


void check_result()
{
    int i, j;

    for(i=0; i<POP_SIZE; i++){
	fprintf(stderr,"gene no.%d = ",i);
	for(j=0; j<GENE_LENGTH; j++){
	    fprintf(stderr,"%d ",gene[i][j]);
	}
	fprintf(stderr," => fitness = %d\n",fitness[i]);
    }

}
